---
title: <integer>
slug: Web/CSS/integer
tags:
  - CSS
  - CSS Data Type
  - Data Type
  - Reference
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>&lt;integer&gt;</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Types">data type</a> is a special type of {{cssxref("number")}} that represents a whole number, whether positive or negative. Integers can be used in numerous CSS properties, such as {{cssxref("column-count")}}, {{cssxref("counter-increment")}}, {{cssxref("grid-column")}}, {{cssxref("grid-row")}}, and {{cssxref("z-index")}}.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>&lt;integer&gt;</code> data type consists of one or several decimal digits, 0 through 9 inclusive, optionally preceded by a single <code>+</code> or <code>-</code> sign. There is no unit associated with integers.</p>

<div class="note"><strong>Note:</strong> There is no official range of valid <code>&lt;integer&gt;</code> values. Opera 12.1 supports values up to 2<sup>15</sup>-1, IE up to 2<sup>20</sup>-1, and other browsers even higher. During the CSS3 Values cycle there was a lot of discussion about setting a minimum range to support: the latest decision, <a href="http://lists.w3.org/Archives/Public/www-style/2012Apr/0633.html">in April 2012 during the LC phase</a>, was [-2<sup>27</sup>-1; 2<sup>27</sup>-1], but other values like 2<sup>24</sup>-1 and 2<sup>30</sup>-1 <a href="http://lists.w3.org/Archives/Public/www-style/2012Apr/0530.html">were also proposed</a>. However, the latest spec doesn't specify a range anymore.</div>

<h2 id="Interpolation">Interpolation</h2>

<p>When animated, values of the <code>&lt;integer&gt;</code> data type are interpolated using discrete, whole steps. The calculation is done as if they were real, floating-point numbers; the discrete value is obtained using the <a href="http://en.wikipedia.org/wiki/Floor_function">floor function</a>. The speed of the interpolation is determined by the <a href="/en-US/docs/Web/CSS/timing-function">timing function</a> associated with the animation.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Valid_integers">Valid integers</h3>

<pre class="notranslate">12          Positive integer (without a leading + sign)
+123        Positive integer (with a leading + sign)
-456        Negative integer
0           Zero
+0          Zero, with a leading +
-0          Zero, with a leading -
</pre>

<h3 id="Invalid_integers">Invalid integers</h3>

<pre class="example-bad notranslate">12.0        This is a &lt;number&gt;, not an &lt;integer&gt;, though it represents an integer.
12.         Decimal points are not allowed.
+---12      Only one leading +/- is allowed.
ten         Letters are not allowed.
_5          Special characters are not allowed.
\35         Escaped Unicode characters are not allowed, even if they are an integer (here: 5).
\4E94       Non-arabic numerals are not allowed, even when escaped (here: the Japanese 5, 五).
3e4         Scientific notation is not allowed.
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Values', '#integers', '&lt;integer&gt;')}}</td>
   <td>{{Spec2('CSS4 Values')}}</td>
   <td>No significant change.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Values', '#integers', '&lt;integer&gt;')}}</td>
   <td>{{Spec2('CSS3 Values')}}</td>
   <td>No significant change.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'syndata.html#numbers', '&lt;integer&gt;')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Explicit definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '', '&lt;integer&gt;')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Implicit definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("css.types.integer")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("&lt;number&gt;")}}</li>
</ul>
